//----------------------------------------------------------------------
//MODEULE: adc0.c
//COMMON DESCRIPTION:
//  This module provide Analog to Digital Converter handling and controls. 
//----------------------------------------------------------------------
#include "adc0.h"
#include <avr/signal.h>
//
#ifdef ADC0_ENABLED
  // ADC init procedure
  void adc0_init()
    {// DIVFACTOR
     #ifndef ADC0_DIVFACTOR
       #define ADC0_DIVFACTOR 0x00
     #endif
     //
     #ifdef ADC0_FREE_RUNNING
       // Free running mode
       #ifdef ADC0_INT_PROC
         // Interrupt enable
         output(ADCSR,((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|ADC0_DIVFACTOR));
       #else
         // Interrupt disable
         output(ADCSR,((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|ADC0_DIVFACTOR));
       #endif
     #else
       // Single conversion
       #ifdef ADC0_INT_PROC
         // Interrupt enable
         output(ADCSR,((1<<ADEN)|(1<<ADSC)|(1<<ADIE)|ADC0_DIVFACTOR));
       #else
         // Interrupt disable
         output(ADCSR,((1<<ADEN)|(1<<ADSC)|ADC0_DIVFACTOR));
       #endif
     #endif     
    }
//----------------------------------------------------------------------
  // Get mean and start new conversion
  unsigned int ADC0_GET_MEAN()
    {unsigned int t;
     t=input(ADCL);
     t=t|(input(ADCH)<<0x08);     
     return(t & 0x7FF);
    }
//----------------------------------------------------------------------
  #ifdef ADC0_INT_PROC
    #ifdef ADC0_INT_PROCESS_ENABLE      
      INTERRUPT(SIG_ADC){ADC0_INT_PROC();}
    #else
      SIGNAL(SIG_ADC){ADC0_INT_PROC();}
    #endif
  #endif
//----------------------------------------------------------------------
#endif
