//----------------------------------------------------------------------
//MODEULE: port.c
//COMMON DESCRIPTION:
//  This module contain procedures for write and read byte to and from 
//port.
//It contain procedure for init port also.
//----------------------------------------------------------------------
// Internal declarations
//----------------------------------------------------------------------
#ifdef EXTERNAL_IO_ENABLED
//----------------------------------------------------------------------
#include "extports.h"
unsigned char OPORTSTAY[N_OPORTS];
//----------------------------------------------------------------------
// Write byte MEAN to output port number PORT
void extio_wroport(unsigned char PORT,unsigned char MEAN)
  {unsigned char tsreg,l;
   OPORTSTAY[PORT]=MEAN;  
   // Only for AVR release version  
   tsreg =input(SREG);
   _CLI();
   l = (0x01 << PORT);
   // 
   output(EXTCTRLPORT,0xFF);_NOP();_NOP();
   output(EXTPORTDDR ,0xFF);_NOP();_NOP();
   //
   output(EXTDATADDR ,0xFF);_NOP();_NOP();
   output(EXTDATAPORT,MEAN);_NOP();_NOP();
   //
   output(EXTCTRLPORT,input(EXTCTRLPORT) & (~l));_NOP();_NOP();
   output(EXTCTRLPORT,input(EXTCTRLPORT) | l);_NOP();_NOP();
   output(SREG,tsreg);_NOP();_NOP();
  }
//----------------------------------------------------------------------
// Return means, reading from output port number PORT
unsigned char extio_rdoport(unsigned char PORT)
  {return(OPORTSTAY[PORT]);
  }
//----------------------------------------------------------------------
// Return means, reading from input port number PORT
unsigned char extio_rdiport(unsigned char PORT)
  {unsigned char tsreg,l,d;
   // Only for AVR release version  
   tsreg = input(SREG);
   _CLI();
   l = (0x01 << PORT);
   //
   output(EXTDATADDR, 0x00);_NOP();_NOP();
   output(EXTCTRLPIN, 0xFF);_NOP();_NOP();
   output(EXTPINDDR , 0xFF);_NOP();_NOP();
   //
   output(EXTCTRLPIN,input(EXTCTRLPIN) & (~l));_NOP();_NOP();
   d = input(EXTDATAPIN);
   //
   output(EXTCTRLPIN,0xFF);_NOP();_NOP();
   output(SREG,tsreg);_NOP();_NOP();
   return(d);
  }
//----------------------------------------------------------------------
// Set bit number BIT in output port number PORT
void extio_oport_sbi(unsigned char PORT,unsigned char BIT){extio_wroport(PORT,(OPORTSTAY[PORT] | (1<<BIT)));}
//----------------------------------------------------------------------
// Clear bit number BIT in output port number PORT
void extio_oport_cbi(unsigned char PORT,unsigned char BIT){extio_wroport(PORT,(OPORTSTAY[PORT] & (~(1<<BIT))));}
//----------------------------------------------------------------------
// Test bit number BIT in output port number PORT. 
// Return 0 if bit equals zero and 1 if bit equals one.
unsigned char extio_optst(unsigned char PORT,unsigned char BIT)
  {if(OPORTSTAY[PORT] & (1<<BIT)){return(0x01);}else{return(0x00);}}
//----------------------------------------------------------------------
// Init All Output Ports (write 0xFF to it)
void extio_port_init()
  {unsigned char i;
   for(i=0;i<N_OPORTS;i++)
     {extio_wroport(i,0xFF);}
  }
//----------------------------------------------------------------------
#endif
//----------------------------------------------------------------------
