//----------------------------------------------------------------------
//MODEULE: int0.c
//COMMON DESCRIPTION:
//  This module provide interrupt0 handling and controls. 
//----------------------------------------------------------------------
#include "int0.h"
#include <avr/signal.h>
//
#ifdef INT0_ENABLED
  void int0_init()
    {// Int0 interrupt
     #ifdef INT0_LEVEL0
     #define INT0_LEVRIS 0x00
     #else
     //
       #ifdef INT0_LEVEL1
       #define INT0_LEVRIS 0x01
       #else
       //
         #ifdef INT0_FALLING_EDGE
	 #define INT0_LEVRIS 0x02
         #else
	 //
	   #ifdef INT0_RISING_EDGE
	   #define INT0_LEVRIS 0x03
           #endif
         #endif
       #endif
     #endif
     // Set type of interrupt
     output(MCUCR,(input(MCUCR) & (~(0x03 << ISC00))) | (INT0_LEVRIS << ISC00));
     output(GIMSK,input(GIMSK) | (1 << INT0)); // Enable External Int0
     output(GIFR, input(GIFR)  | (1 << INT0)); // Reset External Int0
    }
#endif
//----------------------------------------------------------------------
#ifdef INT0_ENABLED
  // Interrupt0 handler
  SIGNAL (SIG_INTERRUPT0)
    {//
     #ifdef INT0_0
     INT0_0();
     #endif
     #ifdef INT0_1
     INT0_1();
     #endif
     #ifdef INT0_2
     INT0_2();
     #endif
     #ifdef INT0_3
     INT0_3();
     #endif
    }
#endif    
//----------------------------------------------------------------------
