//----------------------------------------------------------------------
//MODEULE: uart0.h
//COMMON DESCRIPTION:
//  //  This module contain headers for uart0.c 
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef UART0_ENABLED
  void uart0_init();
  #define uart0_init_mac() uart0_init()
  #ifndef UART_SPD_CONST
    // Set speed (speed in Bits/sec)
    void uart0_setspeed(unsigned int speed);
  #endif
  // Main Read-Write Procedures. 
  // (char* c) is a pointer to byte, which will be readed or written
  unsigned char uart0_wr(char* c);// Write to uart0 (or writing-buffer) If byte written sucefully,
                                  // function return TRUE, else function return FALSE
  unsigned char uart0_rd(char* c);// Read from uart0 (or reading-buffer) If byte readed sucefully,
                                  // function return TRUE (non-Zero), else function return FALSE (Zero)
  // Procedure for job with buffers
  #ifdef UART_BUFFERS_ENABLED
  // Functions of clearing buffers
  void uart0_clear_rx_buf(); // recieve buffer
  void uart0_clear_tx_buf(); // transmitt buffer
  unsigned char uart0_txbuf_empty();// Returned TRUE if TX buffer is empty
  unsigned char uart0_rxbuf_empty();// Returned TRUE if RX buffer is empty
  #endif
  // Uart Strings Support
  #ifdef UART_STR_ENABLED
    // Write string from RAM
    void uart_wrstr(unsigned char* s);
    // Write string from Program Memory
    void uart_p_wrstr(unsigned char* s);
    // Write number
    void uart_wrint(unsigned int n);
  #endif
#else
  #define uart0_init_mac()
#endif
//----------------------------------------------------------------------
