//----------------------------------------------------------------------
//MODEULE: key.c
//COMMON DESCRIPTION:
//  This module contain procedures for geting symbol from keyboard.
//----------------------------------------------------------------------
#include "key.h"
//
#ifdef KEY_ENABLED
// Bit 7: if = 1, new key pressed, waiting for call getch()
unsigned char scancode;
unsigned char kbd_delay;
//----------------------------------------------------------------------
// Init key module
void key_init()
  {scancode=0;
  }
//----------------------------------------------------------------------
// Timer Interrupt for keyboard scan. Calling every 0.1sec
//----------------------------------------------------------------------
void key_int()
  {unsigned char k;
   if(!kbd_delay)
     {k=(extio_rdiport(INKEY_PORT) & KEY_MASK);
      if(k!=KEY_MASK)
        {if(!(scancode & 0x80))
	 {scancode = k | 0x80;
	  kbd_delay=KBD_TIME_OUT;
	 }
	}
     }
   else
     {kbd_delay--;
     }
  }
//----------------------------------------------------------------------
// Returns TRUE, if key was pressed. Call getch() for reading key code.
unsigned char iskey()
  {if(scancode & 0x80){return(0x01);}
   else{return(0x00);}
  }
//----------------------------------------------------------------------
// Returns key code and enables reading new key
unsigned char getkey()
  {unsigned char k;
   unsigned char sc=scancode;
   if(sc & 0x80)
     {if(!(sc & 0x01)){k=K_MODE;}
      else if(!(sc & 0x02)){k=K_NEXT;}
      else if(!(sc & 0x04)){k=K_PLUS;}
      else if(!(sc & 0x08)){k=K_SEL;}
      else {k=K_NONE;}
      scancode=0;
     }
   else {k=K_NONE;}
   return(k);
  }
//----------------------------------------------------------------------
// Convert word (max 9999) to array of 4 digits (sym[4])
void int_to_sym(unsigned char sym[4],unsigned int w)
  {unsigned char i;
   unsigned char d;
   unsigned int p=1000;
   //
   for(i=0;i<4;i++)
     {d=w/p;
      sym[i]=d;
      w=w-(p*d);
      p=p/10;
     }
  }
//----------------------------------------------------------------------
// Convert  array of 4 digits (sym[4]) to word (max 9999) and return it
unsigned int sym_to_int(unsigned char sym[4])
  {unsigned char i;
   unsigned int  s=0;
   unsigned int  p=1;   
   for(i=0;i<4;i++)
     {s=s+sym[3-i]*p;
      p=p*10;
     }  
   return(s);
  }
//----------------------------------------------------------------------
// Convert word (in bcd or hex  format) to array of 4 digits (sym[4])
void bcd_to_sym(unsigned char sym[4],unsigned int w)
  {unsigned char i;
   for(i=0;i<4;i++)
     {sym[i]=(w >> ((3-i)*4)) & 0x0F;
     }
  }
//----------------------------------------------------------------------
// Convert sym to word (in bcd or hex  format) to array of 4 digits (sym[4])
unsigned int sym_to_bcd(unsigned char sym[4])
  {unsigned char i;
   unsigned int w=0;
   for(i=0;i<4;i++)
     {w=w+(sym[i] << ((3-i)*4));;
     }
   return(w);
  }
//----------------------------------------------------------------------
#endif
