//----------------------------------------------------------------------
//MODEULE: led.h
//COMMON DESCRIPTION:
//  This module contain headers for led.c
//one-wire protocol.
//----------------------------------------------------------------------
// Common declarations
//----------------------------------------------------------------------
#ifdef LED_MLAN_ENABLED
//
#define led_mlan_init_mac() led_init()
// Switch on led number n
void ledon(unsigned char l,unsigned char led[]);
// Switch off led number n
void ledoff(unsigned char l,unsigned char led[]);
// Enable flash mode for led n
void ledflashon(unsigned char l,unsigned char led[]);
// Disable flash mode for led n
void ledflashoff(unsigned char l,unsigned char led[]);
// Put word to indicator in hex format
void printhexw(unsigned int w,unsigned char led[]);
// Put word to indicator in dec format
void printdecw(unsigned int w,unsigned char led[]);
// Put word to indicator in dec format and first any symbol  SDDD 
void printsym3d(unsigned char sym,unsigned int w,unsigned char led[]);
// Init led module
void led_init();
// Refresh led (must be called every 0.1s)
void leds_refresh();
// Enable automatic refresh leds
void led_start();
// Disable automatic refresh leds
void led_stop();
// Structure, contains data about one indicator
typedef struct {unsigned char line;
                unsigned char adr;
		unsigned char data[8];
               } LED_DATA_H;
// Array of LED_DATA_H
LED_DATA_H LED_DATA[LED_NUM];						 
//----------------------------------------------------------------------
#else
//----------------------------------------------------------------------
#define led_mlan_init_mac()
//----------------------------------------------------------------------
#endif
//----------------------------------------------------------------------

