//----------------------------------------------------------------------
//MODEULE: mlan.h
//COMMON DESCRIPTION:
//  This module contain headers for mlan.c
//----------------------------------------------------------------------
#ifdef MICROLAN_MASTER_ENABLE
#define mlan_init_mac() mlan_init()
// Initialize protocol MLAN
void mlan_init();
// MLAN Interrupt handler
void mlan_int();
// Send data to bus (automatic generate CRC) 
// Packet: adr,cmd,data,crc
// adr - device adress 
// cmd - command
// len - length of data
// line - number of line
// data - adress (NULL if command only sending) of data block
unsigned char mlan_transfer(unsigned char adr,unsigned char cmd,unsigned char len,
                            unsigned char line,unsigned char* data, unsigned char answ);
// Returns true if command is not executing and clearing MLAN_CTRL
unsigned char is_mlan_done();
// Answer buffer
extern unsigned char MLAN_BUF[];
// Calculate answercrc (true/false)
unsigned char mlan_answer_crcansw();
//----------------------------------------------------------------------
// Standard commands (code: 0x00-0x7F)
// Cold Restart of devices
#define STD_CMD_RESET   0x00
// Hot Restart of device
#define STD_CMD_GETRDY  0x01
// Test (read one byte and send it to back)
#define STD_CMD_TST     0x02
//----------------------------------------------------------------------
#else
//----------------------------------------------------------------------
#define mlan_init_mac()
//----------------------------------------------------------------------
#endif
//----------------------------------------------------------------------
