//----------------------------------------------------------------------
//MODEULE: mlan.h
//COMMON DESCRIPTION:
//  This module contain headers for mlan.c
//----------------------------------------------------------------------
#ifdef MICROLAN_SLAVE_ENABLE
  #define mlans_init_mac() MLANS_INIT()
  //--------------------------------------------------------------------
  // Standard commands (code: 0x00-0x7F)
  // Cold Restart of devices
  #define STD_CMD_RESET   0x00
  // Hot Restart of device
  #define STD_CMD_GETRDY  0x01
  // Test (read one byte and send it to back)
  #define STD_CMD_TST     0x02
  //--------------------------------------------------------------------
  // Initialize protocol MLAN
  void MLANS_INIT();
  // MLAN Timer handler
  void MLANS_PTIMER();
  // MLAN Interrupt handler
  void MLANS_INT();
  //--------------------------------------------------------------------
  // If it macros defined, then it must be called after ending operation with bus
  // #define MLANS_U_READ_ADR_END()
  // #define MLANS_U_READ_DATA_END()
  // #define MLANS_U_WRITE_DATA_END()
#else
  #define mlans_init_mac()
#endif
//----------------------------------------------------------------------
