//----------------------------------------------------------------------
// MODEULE: res_mlan.h
// COMMON DESCRIPTION:
//   This module contain declaration for microlan protocols
//----------------------------------------------------------------------
// SLAVE mode
//----------------------------------------------------------------------
//#define MICROLAN_SLAVE_ENABLE
// Following definitions active ONLY if microlanslave enabled
#ifdef MICROLAN_SLAVE_ENABLE
  // Set interrupt handler
//  #define INT0_0()                MLANS_INT()
  // Set timer interrupt handler
//  #define T_INT_MAX_0()           MLANS_PTIMER()
  // Set timer frequency (automatic calculate)
//  #define MICROLAN_SLAVE_F_TINT   F_TIMER0
  // Set microlan slave device adress
//  #define MLANS_ADRESS            0xAE
  // Mlan hardware ports and ints
//  #define MLANSPORT   PORTD
//  #define MLANSPIN    PIND
//  #define MLANSDDR    DDRD
//  #define MLANSRDBIT  PD2
//  #define MLANSWRBIT  PD3
//
#endif
// For handling user command must be defined next macros:
// -----------------------
//   If command MLANS_COMMAND is valid user command, then procedure
// MLAN_SLAVE_U_ISVALCMD must be return TRUE.
// MLANS_COMMAND   - command 
// MLANS_READ  - pointer to number of bytes, which must be read for it command
// MLANS_WRITE - pointer to number of bytes, which must be written for it command after
//               calling MLAN_SLAVE_U_VALCMDHDL
//   Example definition :
// unsigned char USER_ISVALCMD(unsigned char MLANS_COMMAND,unsigned char* MLANS_READ,unsigned char* MLANS_WRITE);
// #define MLAN_SLAVE_U_ISVALCMD(MLANS_COMMAND,MLANS_READ,MLANS_WRITE) 
//         USER_ISVALCMD(MLANS_COMMAND,MLANS_READ,MLANS_WRITE);
// -----------------------
//   This procedure calls after recieving all data
// MLANS_COMMAND   - command 
// MLANS_RD_BUFFER - pointer to read buffer
// MLANS_WR_BUFFER - pointer to write buffer
//   Example definition :
// void USER_VALCMDHDL(unsigned char MLANS_COMMAND,unsigned char* MLANS_RD_BUFFER,unsigned char* MLANS_WR_BUFFER)
// #define MLAN_SLAVE_U_VALCMDHDL(MLANS_COMMAND,MLANS_RD_BUFFER,MLANS_WR_BUFFER) 
//     USER_VALCMDHDL(MLANS_COMMAND,MLANS_RD_BUFFER,MLANS_WR_BUFFER);
//----------------------------------------------------------------------
// If it macros defined, then it must be called after ending operation with bus
// void MLANS_U_READ_ADR_END_PROC();
// #define MLANS_U_READ_ADR_END() MLANS_U_READ_ADR_END_PROC()
//----------------------------------------------------------------------
// If it macros defined, then it must be called after ending operation with bus
// void MLANS_U_READ_DATA_END_PROC();
// #define MLANS_U_READ_DATA_END() MLANS_U_READ_DATA_END_PROC()
//----------------------------------------------------------------------
// If it macros defined, then it must be called after ending operation with bus
// void MLANS_U_WRITE_DATA_END_PROC();
// #define MLANS_U_WRITE_DATA_END() MLANS_U_WRITE_DATA_END_PROC()
//----------------------------------------------------------------------

//----------------------------------------------------------------------
// MASTER mode
//----------------------------------------------------------------------
//#define MICROLAN_MASTER_ENABLE
// You may use external or internal port
#define MICROLAN_MASTER_EXTPORTS_ENABLED
// Following definitions active ONLY if microlan master enabled
#ifdef MICROLAN_MASTER_ENABLE
 #ifdef MICROLAN_MASTER_EXTPORTS_ENABLED
  // Mlan hardware ports (external ports)
//  #define MLANPORT 0x02
//  #define MLANPIN  0x07
 #else
  // Mlan hardware ports (internal ports)
//  #define MLANPORT     PORTC
//  #define MLANPIN      PINC
//  #define MLAN_INBIT   0x00
//  #define MLAN_OUTBIT  0x00
//  #define MLAN_PORTDDR DDRC
//  #define MLAN_PINDDR  DDRC
 #endif
  // Length of buffer
//  #define MLAN_BUF_LEN 0x10 
  // Set timer interrupt handler
//  #define T_INT_MAX_0()           mlan_int()
#endif
//----------------------------------------------------------------------
