//----------------------------------------------------------------------
//MODEULE: sysdef.h
//COMMON DESCRIPTION:
//  This module contain common declaration for hardware
//----------------------------------------------------------------------
// Timers
#include "res_timers.h"
// Interrupts
#include "res_ints.h"
// MicroLAN
#include "res_mlan.h"
// Analog to Digital Converters (ADC)
#include "res_adc.h"
// Pulse-Width Modulator (PWM)
#include "res_pwm.h"
// External port and pin (1554IR23, 1554AP5, etc)
#include "res_extio.h"
// Keyboard handler
#include "res_key.h"
// Supprt of led indcators of MicroLAN bus (on 1878BE1 based, for example)
#include "res_led.h"
// Support internal UART
#include "res_uart.h"
// All *.h files
#include "sys.h"
//----------------------------------------------------------------------
#define F_CLK            8000000
//----------------------------------------------------------------------
// Create procedure, which called name() one time, without
// repeat entry 
#define settask(name)\
  unsigned char name##var;\
  void task##name()\
    {unsigned char tsreg;\
     if(!name##var)\
     {name##var=1;\
      tsreg=input(SREG);\
      _SEI();\
      name();\
      output(SREG,tsreg);\
      name##var=0;\
     }\
    }
//----------------------------------------------------------------------
